<?php
############################################################################
#
# (c) 	Markus Wolf, 1998-2006  |  info@interaktiv.net
#       iAn interAKTIVnet GmbH  |  http://www.interaktiv.net
#       Tel. 07031-714740       |  Fax. 07031-714744
#
############################################################################
#
#  Diese Software ist das Eigentum der iAn interAKTIVnet GmbH und nach dem 
#  Urheberrecht geschtzt - es  handelt sich NICHT um Freeware. Jede Nutzung 
#  der Software ohne eine gltige Lizenzvereinbarung, wird zivil- und 
#  strafrechtlich verfolgt.
#
#  This Software is the property of iAn interAKTIVnet GmbH and is protected 
#  by copyright law - it is NOT Freeware. Any unauthorized use of this 
#  software without a valid license is a violation of the license agreement 
#  and will be prosecuted by civil and criminal law.
#
#  Dieses Script darf von jedermann kostenlos benutzt und gendert werden, 
#  solange dieser Copyright-Verweis, der Link bei der Ausgabe und die 
#  restlichen Kommentare erhalten  bleiben. Mit dem Einsatz dieses Skripts 
#  akzeptieren Sie, da die interAKTIVnet GmbH von jeglicher Haftung und 
#  Gewhrleistung hinsichtlich des Einsatzes befreit ist.
#
#  Weitere Infos : http://www.phpunity.de/php/scripts/
# 
#  Der Verkauf dieses Skripts, auch in modifizierter Form, ist ohne
#  vorherige Absprache ausdrcklich untersagt.
# 
#  Um dieses Skript ber das Internet oder irgendein anderes Medium
#  weiterzuverbreiten, bentigen Sie vorher meine Erlaubnis. In jeden Fall
#  mssen der Copyright-Verweis und die restlichen Kommentare erhalten 
#  bleiben.
#
############################################################################
#
#  PHPUNITY.DE : phpunity.mail2friend
#
############################################################################

############################################################################
# phpunity.mail2friend :: Konfiguration
############################################################################


// Subject der eMail :: Dieser Text erscheint im Subject-Feld der eMail

$mail_subject = "Eine Empfehlung von einem Freund...";


// Geben Sie hier eine gltige eMail-Adresse als Absender von Ihnen an
// Bei manchen Providern ist hufig besonders wichtig, da diese eMail-
// Adresse auch bei diesem Provider gehostet wird (Spam-Schutz)

$email = "xyz@ihre_domain.de";


// Logfile aktivieren?
// In diesem Logfile werden alle gemachten Angaben gespeichert (incl. IP-Adresse)
// 0 => Nein :: Es wird kein Logfile geschrieben
// 1 => Ja :: Empfehlungen werden in einer Datei gespeichert

$logact = 1;


// eMail an den Administrator (Kopie der Empfehlung) //
// 0 => Nein :: Es wird KEINE eMail verschickt
// 1 => Ja :: Es wird eine eMail verschickt
$admin_copy = 1;

// eMail-Adresse des Administrators
$admin_mail = "xyz@ihre_domain.de";


// IP-Sperre //
// Hier sollten Sie fr sich einen Mittelweg finden, der geeignet ist, Spammer zu
// blocken und gleichzeitig "faire" User nicht unntig einzuschrnken.
// Bedenken Sie dabei, da IP-Adressen bei der groen Mehrheit der User dynamisch
// vergeben werden und sich hufig ndern knnen.

// Anzahl der Empfehlungen, die ein User innerhalb der vorgegebenen Zeit
// versenden darf (Stk.)
$ip_count = 4;

// Zeit der Speicherung der IP-Adressen in Minuten (ein Tag hat 1440 Minuten ;-)
$ip_time = 30;


// Referer-Ersatz
// Nicht jeder Browser oder Proxy-Server lsst die bertragung des Referers (also der Seite,
// von der ein User kommt) zu. Diese Angabe wird jedoch von dem Script bentigt, um zu "wissen"
// welche Seite empfohlen werden soll.
// Hier knnen Sie eine URL (z.B. die Ihrer Homepage) eingeben, die in einem solchen
// Falle ersatzweise als Link verschickt wird. 

$m2f_page = "http://www.ihre_domain.de/index.htm";


// Weiterleitungsseite
// In der Grundeinstellung wird jemand, der eine Seite empfohlen hat "kommentarlos" wieder
// auf die Seite geleitet, die er/sie empfohlen hat. Sollten Sie lieber eine individuelle Besttigungs-
// Seite anzeigen wollen, knnen Sie nachfolgende Einstellungen ndern.

// Eigene Besttigungsseite? 0 = Nein || 1 = Ja
$show_ok = 1;

// URL der Besttigungsseite
$show_ok_url = "http://www.ihre_domain.de/bestaetigungs_seite.htm";



############################################################################
# phpunity.mail2friend :: Programmablauf (ab hier nichts mehr ndern)
############################################################################


$set = $_GET['set'];
$ref = $_POST['referer'];

// referer auslesen
if (!isset($set)) {

	$ref = $_SERVER['HTTP_REFERER'];

	if (empty($ref)) { // kein Referer ermittelt

		$ref = $m2f_page; 	
	}
}



############################################################################
# phpunity.mail2friend :: Eingabe berprfen (Mufelder)
############################################################################

if ( $set=="sendmail" ) {

	// Umgebungsvariablen auslesen
	$mail_from = strip_tags($_POST["mail_from"]);
	$name_from = strip_tags($_POST["name_from"]);
	$mail_to = strip_tags($_POST["mail_to"]);
	$name_to = strip_tags($_POST["name_to"]);
	$message = strip_tags($_POST["message"]);
	$message = stripslashes($message);

	// Template laden
	$mts  =  join('', file("./tmpl/m2f_form.htm"));

	// Anzahl Mufelder ermitteln
	preg_match_all("=\<\!\-\-.(.*):.*\-\-\>=",$mts,$validates);
	$valcount = count($validates[1]);

	// Mufelder durchlaufen + Fehlermeldungen ausgeben
	for ($i=0;$i<=$valcount;$i++) {

		$check_type = explode("&",$validates[1][$i]);

		// Namen berprfen
		if ($check_type[0]=="name") {
		
			if (empty($$check_type[1])) {
				
				$mts = preg_replace("=\<\!\-\-.name&$check_type[1]:.(.*)\|\|.*\-\-\>=","\\1",$mts);
			 	$valform = "error";
			
			} elseif(strlen($$check_type[1]) < 2) {
			    
			    $mts = preg_replace("=\<\!\-\-.name&$check_type[1]:.*\|\|(.*)\-\-\>=","\\1",$mts);
				$valform = "error";
			}
		}

		// eMail-Adressen berprfen
		if ($check_type[0]=="email") {   
			
			if (empty($$check_type[1])) {
			
				$mts = preg_replace("=\<\!\-\-.email&$check_type[1]:.(.*)\|\|.*\-\-\>=","\\1",$mts);
				$valform = "error";
		
			} elseif(!preg_match("/^[\,\#\!\%_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.){1,}[a-z]{2,4}$/i",$$check_type[1])) {
			
				$mts = preg_replace("=\<\!\-\-.email&$check_type[1]:.*\|\|(.*)\-\-\>=","\\1",$mts);
				$valform = "error";
			}
		}

		// Telefon-/Faxnummer berprfen (Ziffern, -, + und / sind gltig
		if ($check_type[0]=="tel") {

			if (empty($$check_type[1])) {
		
				$mts = preg_replace("=\<\!\-\-.tel&$check_type[1]:.(.*)\|\|.*\-\-\>=","\\1",$mts);
				$valform = "error";
		
			} elseif(!preg_match("=[\-\+\/0-9]+$=i",$$check_type[1])) {
				
				$mts = preg_replace("=\<\!\-\-.tel&$check_type[1]:.*\|\|(.*)\-\-\>=","\\1",$mts);
				$valform = "error";
			}
		}

		// Zahlen oder Betrge berprfen (Ziffern, . und , sind gltig)
		if ($check_type[0]=="num") {
			
			if (empty($$check_type[1])) {
				
				$mts = preg_replace("=\<\!\-\-.num&$check_type[1]:.(.*)\|\|.*\-\-\>=","\\1",$mts);
				$valform = "error";
			
			} elseif(!preg_match("=[\.\,\/0-9]+$=i",$$check_type[1])) {
			
				$mts = preg_replace("=\<\!\-\-.num&$check_type[1]:.*\|\|(.*)\-\-\>=","\\1",$mts);
				$valform = "error";
			}
		}

		// Prfung, ob beliebige Eingabe erfolgt ist
		if ($check_type[0]=="eing") {
			
			if (empty($$check_type[1])) {
		    	$mts = preg_replace("=\<\!\-\-.eing&$check_type[1]:.(.*).\-\-\>=","\\1",$mts);
				$valform = "error";
			}		
		}
	}

	if ($valform=="error") {

		// Ersetzungen durchfhren
		$mts = preg_replace("=\[referer\]=","$referer",$mts);
		$mts = preg_replace("=\[name_from\]=","$name_from",$mts);
		$mts = preg_replace("=\[mail_from\]=","$mail_from",$mts);
		$mts = preg_replace("=\[name_to\]=","$name_to",$mts);
		$mts = preg_replace("=\[mail_to\]=","$mail_to",$mts);
		$mts = preg_replace("=\[message\]=","$message",$mts);
		$mts = preg_replace("=\<\!\-\-.*\-\-\>=","",$mts);

		// Formular bei Fehlern ausgeben
		echo $mts;
	
	} else {
    	
    	$set = "sendmail_ok";
	}
}



############################################################################
# phpunity.mail2friend :: eMail verschicken
############################################################################

if ($set=="sendmail_ok") {

	//IP-Adresse des Senders ermitteln
	$senders_ip = $_SERVER['REMOTE_ADDR'];

	//IP-Adresse, Anzahl und Zeit prfen
	$ip_alarm = check_ipfile($senders_ip);

	// Fehlerseite ausgeben
	if ($ip_alarm==1) {
		
		$error_tmpl = join('', file("./tmpl/m2f_error.htm"));
		echo $error_tmpl;
		exit;

	} else { // oder Nachricht verarbeiten

		// Weiterleitung
		if ($show_ok==1) { 
			Header("Location: ".$show_ok_url); 
		} else {
			Header("Location: ".$ref); 
		}

		// Umgebungsvariablen auslesen
		$mail_from = strip_tags($_POST["mail_from"]);
		$name_from = strip_tags($_POST["name_from"]);
		$mail_to = strip_tags($_POST["mail_to"]);
		$name_to = strip_tags($_POST["name_to"]);
		$message = strip_tags($_POST["message"]);
		$message = stripslashes($message);

		// eMail verschicken
		$mailto = $mail_to;
		$subject	 = $mail_subject;

		// eMail-Template laden
		$mail_tmpl  =  join('', file("./tmpl/m2f_email.txt"));

		// Ersetzungen durchfhren
		$mts = preg_replace("=\[name_from\]=","$name_from",$mail_tmpl);
		$mts = preg_replace("=\[name_to\]=","$name_to",$mts);
		$mts = preg_replace("=\[m2f_link\]=","$referer",$mts);
		$mts = preg_replace("=\[message\]=","$message",$mts);

		if ($admin_copy==1) {
			
			$header = "From: $email\n";
			$header .= "Bcc: $admin_mail";
		
		} else {
    
    		$header="From: $email";
		}

		// ...eMail verschicken
		@mail ($mailto,$subject,$mts,$header);


		// Anzahl der Nachrichten zhlen
		$countm2f = "./log/countm2f.txt";

		// berprfung, ob es bereits eine "countm2f.txt" gibt
		// Wenn nicht, wird sie angelegt und mit dem Wert 1 versehen
		if (!file_exists($countm2f)) {
		
    		$zahldatei = fopen($countm2f,"w+");
			$zahl = 1;
			fwrite($zahldatei,$zahl);
			fclose($zahldatei);
	
		} else {
    
    		// Zahl im Counter wird um 1 erhht und in die Datei geschrieben
    		$nummer = file($countm2f);
			$nummer_neu = $nummer[0];
			$zahldatei = fopen($countm2f,"r+");
			$nummer_neu++;
			fwrite($zahldatei,$nummer_neu);
			fclose($zahldatei);
		}

		// Logfile
		if ($logact==1) {

			$message = preg_replace("=(\r\n)="," ",$message);
			$logcontent = "$referer|$mail_to|$name_to|$mail_from|$name_from|$message|$senders_ip\n";
			$logfile = "./log/logm2f.txt";

			// berprfung, ob es bereits eine "logm2f.txt" gibt
			// Wenn nicht, wird sie angelegt und die erste Zeile wird geschrieben
			if (!file_exists($logfile)) {
				
    			$logdat = fopen($logfile,"w+");
				fwrite($logdat,$logcontent);
				fclose($logdat);

			} else {
    	
    			$logdat = fopen($logfile,"a");
				fwrite($logdat,$logcontent);
				fclose($logdat);
			}
		}
	}
}



############################################################################
# phpunity.mail2friend :: Formular laden
############################################################################

if ( !isset($set) ) {

	$form_tmpl = join('', file("./tmpl/m2f_form.htm")) ;

	//Ersetzungen durchfhren
	$mts = preg_replace("=\[referer\]=","$ref",$form_tmpl) ;
	$mts = preg_replace("=\[name_from\]=","",$mts) ;
	$mts = preg_replace("=\[mail_from\]=","",$mts) ;
	$mts = preg_replace("=\[name_to\]=","",$mts) ;
	$mts = preg_replace("=\[mail_to\]=","",$mts) ;
	$mts = preg_replace("=\[message\]=","",$mts) ;
	$mts = preg_replace("=\<\!\-\-.*\-\-\>=","",$mts) ;

	echo $mts ;
}



############################################################################
# phpunity.mail2friend :: IP-Adresse checken
############################################################################

function check_ipfile($senders_ip) {


global $ip_time, $ip_count ;    
$ip_dat = "./log/ip/$senders_ip" ;
$ip_folder = opendir("./log/ip") ;
$now_date = date("U") ;


###
#alte ip-files lschen

while ( $datfile = readdir($ip_folder) ) {
    
    if ( preg_match("=.*=", $datfile) ) {
	
		$dat_date = date("U", filectime("./log/ip/$datfile")) ;
		$keep_time = 60*$ip_time ;
		$dif_time = $now_date - $keep_time ;
	
		if ( $dat_date < $dif_time ) {
			
		    @unlink("./log/ip/$datfile") ;
		}
	}
}

closedir($ip_folder) ;


###
#IP hochzhlen

if ( file_exists("$ip_dat") ) {

    $ip_anz = file($ip_dat) ;
	$ip_anz_neu = $ip_anz[0] ;

	if ( $ip_anz_neu==($ip_count-1) ) {

		$ip_alarm = 1 ;

	} else {
	
	    $ip_datei = fopen($ip_dat,"r+") ;
		$ip_anz_neu++ ;
		fwrite($ip_datei,$ip_anz_neu) ;
		fclose($ip_datei) ;
	}
}


###
#Counter erstellen, falls nicht vorhanden

if ( !file_exists("$ip_dat") ) {
	
   	$ip_file = fopen("$ip_dat","w+") ;
	fclose ($ip_file) ; 
}


###
#Rckgabe Status

return ($ip_alarm) ;


} 



############################################################################
# END
############################################################################

?>
